$LIST
$REGISTERBANK (0,1)
$NOSYMBOLS
$PAGEWIDTH (130)
NAME    IIC
;
;       Includes: EQREG652.ASM
;
$NOLIST
$INCLUDE (EQREG652.ASM)
$LIST
;
;              
;*************************************************************************
;               *                                                             
;         *
;               *     Module       : IIC51M.ASM General purpose IIC
;Procedures.         *
;               *                                                             
;         *
;               *     Version      : 0.5                                      
;         *
;               *                                                             
;         *
;               *     Written by   : R. Brink                                           *
;               *                    Philips Components                                 *
;               *                    Product Concept Application Laboratory Eindhoven   *
;               *                    ( PCALE ) The Netherlands                          *
;               *                                                                       *
;               *     Written at   :    dec  1987                                       *
;               *                                                                       *
;               *     Last update  : 24 mar  1989                                       *
;               *                                                                       *
;               *     Status       : PLM51 DEVELOPMENT                                  *
;               *                                                                       *
;               *     Note(s)      : All Timing in this module is calculated according  *
;               *                    to 12 Mhz XTAL Frequency ( 1 usec cycle )          *
;               *                                                                       *
;               *************************************************************************
;
; Public labels defined in this Module:
; *************************************
        public  ?IIC_Test_Device
        public  ?IIC_Test_Device?BYTE
        public  ?IIC_Write
        public  ?IIC_Write?BYTE
        public  ?IIC_Write_Sub
        public  ?IIC_Write_Sub?BYTE
        public  ?IIC_Write_Sub_SWInc
        public  ?IIC_Write_Sub_SWInc?BYTE
        public  ?IIC_Write_Memory
        public  ?IIC_Write_Memory?BYTE
        public  ?IIC_Write_Sub_Write
        public  ?IIC_Write_Sub_Write?BYTE
        public  ?IIC_Write_Sub_Read
        public  ?IIC_Write_Sub_Read?BYTE
        public  ?IIC_Read
        public  ?IIC_Read?BYTE
        public  ?IIC_Read_Sub
        public  ?IIC_Read_Sub?BYTE
        public  ?IIC_Read_Status
        public  ?IIC_Read_Status?BYTE
        public  ?Init_IIC
        public  ?Init_IIC?BYTE
;
; Externals Used in this Module:
; ******************************
;       NONE
$EJECT
;
;       *****************
;       * IIC Constants *
;       *****************
IICRetries      equ 5           ; Number of IIC Retries done
IICTimeOut      equ 100         ; 100 ms IIC Time Out Time
NVM_Write_Delay equ 40          ; 40 ms NV Memory Write Delay
;
;       *****************************************
;       * IICInOut Control Byte Constants       *
;       * Note: Low Nibble are Status Bits      *
;       *       High Nibble are Control Bits    *
;       *****************************************
;
;       High Nibble IICCntrl
;
SLREAD          equ 7                   ; Read Slave = 1
mSlread         equ 1 SHL SLREAD        ; /
SLNOMEM         equ 6                   ; No Memory Slave = 1
mSlnomem        equ 1 SHL SLNOMEM       ; /
SLNOSUB         equ 5                   ; No Slave Subaddress = 1
mSlnosub        equ 1 SHL SLNOSUB       ; /
SLNOINCR        equ 4                   ; No Auto Incrementing Subaddress = 1
mSlnoincr       equ 1 SHL SLNOINCR      ; /
;
_Test_Device     equ mSlnomem+mSlnosub          ; Test Device ( Write SlvAdr Only )
_Write           equ mSlnomem+mSlnosub          ; Write without Subadr
_Write_Sub       equ mSlnomem                   ; Write with Subadr with Auto Incr.
_Write_Memory    equ mSlnoincr                  ; Write Memory ( Byte By Byte + Delay )
_Write_Sub_SWInc equ mSlnomem+mSlnoincr         ; Write with Subadr without Auto Incr.
_Read_Sub        equ mSlnomem+mSlread           ; Read with Subadr
_Read            equ mSlnomem+mSlnosub+mSlread  ; Read ( No Subadr. )
;
;       Low Nibble IICCntrl
;
ERROR           equ 0                    ; General Error Bit
mError          equ 1 SHL ERROR          ; /
MSTNOTREADY     equ 1                    ; Master not Ready ( Xfer is Pending/in Progress )
mMstNotReady    equ 1 SHL MSTNOTREADY    ; /
BYTE1EXPECTED   equ 2                    ; 1st Byte Expected Bit
mByte1Expected  equ 1 SHL BYTE1EXPECTED  ; /
INBLOCK2        equ 3                    ; Transmitting/Receiving Block 2 Bit
mInBlock2       equ 1 SHL INBLOCK2       ; /
$EJECT
;
;       *************************************************************************
;       * Constants to load in the 80c652 SIO1 Register s1con                   *
;       * All Constants include:                                                *
;       *       ENS1    = 1                                                     *
;       *       SI      = 0                                                     *
;       *       CR1 CR0 Detemine the Clock Frequency ( Based on 12Mc uC ):      *
;       *        0   0  12.5 kHz                                                *
;       *        0   1  100  kHz                                                *
;       *        1   0  200  kHz ( <= 6Mc uC )                                  *
;       *        1   1  0.5-62.5 kHz ( Timer 1, Mode 2, Reload 0..254 )         *
;       *************************************************************************
mCR1            equ     2                       ; CR1 Bit Mask
mCR0            equ     1                       ; CR0 Bit Mask
IICClockRate    equ     mCR0                    ; 100 kHz IIC
;IICClockRate   equ     mCR0+mCR1               ; Timer 1 Controled IIC Speed
;IICTimerReload equ     254                     ; 62.5 kHz IIC Speed If CR1 = CR0 = 1
NSTA_STO_AA     equ     0d4h+IICClockRate       ; Generates STOP
NSTA_NSTO_AA    equ     0c4h+IICClockRate       ; Releases BUS and ACK
NSTA_NSTO_NAA   equ     0c0h+IICClockRate       ; Releases BUS and NOT ACK
STA_NSTO_AA     equ     0e4h+IICClockRate       ; Release BUS and set STA
;
$EJECT
;       *********************************************************
;       * Data / Register Definitions                           *
;       *********************************************************
;
IICBit          Segment Bit
                Rseg    IICBit
;
                public  IIC_Error
IIC_Error:      dbit    1               ; IIC Error Bit
;
IICBitAdr       Segment Data BitAddressable
                Rseg    IICBitAdr
;
IICCntrl:       ds      1               ; Bit Addressable IIC Control Register
;
IICPar          Segment Data
                Rseg    IICPar
;
?IIC_Test_Device?BYTE:                  ; Parameter Locations for PLM51
?IIC_Write?BYTE:                        ;          /
?IIC_Write_Sub?BYTE:                    ;         /
?IIC_Write_Sub_SWInc?BYTE:              ;        /
?IIC_Write_Memory?BYTE:                 ;       /
?IIC_Write_Sub_Write?BYTE:              ;      /
?IIC_Write_Sub_Read?BYTE:               ;     /
?IIC_Read?BYTE:                         ;    /
?IIC_Read_Sub?BYTE:                     ;   /
?IIC_Read_Status?BYTE:                  ;  /
?Init_IIC?BYTE:                         ; /
;
SlaveAddress:   ds      1               ; Slave Address Include R/W
DataCount1:     ds      1               ; Block 1 Count
DataIndex1:     ds      1               ; Block 1 Transfer Buffer Address
SubAddress:     ds      1               ; Sub Address ( If Any )
DataCount2:     ds      1               ; Block 2 Count
DataIndex2:     ds      1               ; Block 2 Transfer Buffer Address
;
$EJECT
;       *****************************************************************
;       *                                                               *
;       *  Explanation of Symbols Used in Procedures Comment            *
;       *                                                               *
;       *       Slv             - SlaveAddress                          *
;       *       SlvW            - SlaveAddress + Write                  *
;       *       SlvR            - Slave Address + Read                  *
;       *       Sub             - SubAddress                            *
;       *       D1[0..L-1]      - Array of Data Bytes ( DataIndex1 )    *
;       *       L               - Length of Array D1 ( DataCount1 )     *
;       *       D2[0..M-1]      - Array of Data Bytes ( DataIndex2 )    *
;       *       M               - Length of Array D2 ( DataCount2 )     *
;       *       S               - Start Condition                       *
;       *       P               - Stop Condition                        *
;       *       A               - Acknowledge                           *
;       *       N               - Negative Acknowlege                   *
;       *                                                               *
;       *****************************************************************
$EJECT
IICCode         Segment Code InBlock
                Rseg    IICCode
;
; *******************************************************************************
; * IIC_Test_Device:                                                            *
; *     PROCEDURE ( SlaveAddress ) BYTE/BIT/None ;                              *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A P                                                              *
; *                                                                             *
; *******************************************************************************
?IIC_Test_Device:
                mov     DataCount1,#0           ; No Data
                mov     a,#_Test_Device
                sjmp    IICInOutBlock1
;
; *******************************************************************************
; * IIC_Write_Memory:                                                           *
; *     PROCEDURE ( SlaveAddress, Count, SourcePtr, SubAddr ) BYTE / BIT / None *
; *                                                                             *
; *     L   = Count                                                             *
; *     D1  = SourcePtr                                                         *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub     A D1[0]   A P  { DelayNVMemory }                       *
; *     S SlvW A Sub+1   A D1[1]   A P  { DelayNVMemory }                       *
; *     .................................................                       *
; *     S SlvW A Sub+L-1 A D1[L-1] A P  { DelayNVMemory }                       *
; *                                                                             *
; *******************************************************************************
?IIC_Write_Memory:
                mov     a,#_Write_Memory
                sjmp    IICInOutBlock1
;
; *******************************************************************************
; * IIC_Read_Sub:                                                               *
; *     PROCEDURE ( SlaveAddress, Count, DestPtr, SubAddr ) BYTE / BIT / None ; *
; *                                                                             *
; *     M   = Count                                                             *
; *     D2  = DestPtr                                                           *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub A S SlvR A D2[0] A D2[1] A ..... A D2[L-1] N P             *
; *                                                                             *
; *******************************************************************************
?IIC_Read_Sub:   mov     a,#_Read_Sub
                sjmp    IICInOutBlock2
$EJECT
;
; *******************************************************************************
; * IIC_Write_Sub:                                                              *
; *     PROCEDURE ( SlaveAddress, Count, SourcePtr, SubAddr ) BYTE / BIT / None *
; *                                                                             *
; *     L   = Count                                                             *
; *     D1  = SourcePtr                                                         *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub A D1[0] A D1[1] A ..... A D1[L-1] A P                      *
; *                                                                             *
; *******************************************************************************
?IIC_Write_Sub:
                mov     a,#_Write_Sub
                sjmp    IICInOutBlock1
;
; *******************************************************************************
; * IIC_Write_Sub_SWInc:                                                        *
; *     PROCEDURE ( SlaveAddress, Count, SourcePtr, SubAddr ) BYTE / BIT / None *
; *                                                                             *
; *     L = Count                                                               *
; *     D1= SourcePtr                                                           *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub     A D1[0]   A P                                          *
; *     S SlvW A Sub+1   A D1[1]   A P                                          *
; *     ..............................                                          *
; *     S SlvW A Sub+L-1 A D1[L-1] A P                                          *
; *                                                                             *
; *******************************************************************************
?IIC_Write_Sub_SWInc:
                mov     a,#_Write_Sub_SWinc
                sjmp    IICInOutBlock1
;
; *******************************************************************************
; * IIC_Write:                                                                  *
; *     PROCEDURE ( SlaveAddress, Count, SourcePtr ) BYTE / BIT / None ;        *
; *                                                                             *
; *     L = Count                                                               *
; *     D1= SourcePtr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A D1[0] A D1[1] A ..... A D1[L-1] A P                            *
; *                                                                             *
; *******************************************************************************
?IIC_Write:      mov     a,#_Write
                sjmp    IICInOutBlock1
$EJECT
;
; *******************************************************************************
; * IIC_Read_Status:                                                            *
; *     PROCEDURE ( SlaveAddress, DestPtr ) BYTE / BIT / None ;                 *
; *                                                                             *
; *     M = 1                                                                   *
; *     D2= DestPtr                                                             *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvR A D2[0] N P                                                      *
; *                                                                             *
; *******************************************************************************
?IIC_Read_Status:
                mov     DataIndex1,DataCount1
                mov     DataCount1,#1
                ; Fall Into IIC_Read
;
; *******************************************************************************
; * IIC_Read:                                                                   *
; *     PROCEDURE ( SlaveAddress, Count, DestPtr ) BYTE / BIT / None ;          *
; *                                                                             *
; *     M = Count                                                               *
; *     D2= DestPtr                                                             *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvR A D2[0] A D2[1] A ..... A D2[M-1] N P                            *
; *                                                                             *
; *******************************************************************************
?IIC_Read:
                orl     SlaveAddress,#00000001b ; Set Read Bit in SlaveAddress
                mov     a,#_Read
                sjmp    IICInOutBlock2
;
; *******************************************************************************
; * IIC_Write_Sub_Write:                                                        *
; *     PROCEDURE ( SlaveAddress, Count1, SourcePtr1, SubAddr,                  *
; *                               Count2, SourcePtr2 ) BYTE / BIT / None ;      *
; *                                                                             *
; *     L   = Count1                                                            *
; *     D1  = SourcePtr1                                                        *
; *     M   = Count2                                                            *
; *     D2  = SourcePtr2                                                        *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub A D1[0] A D1[1] A ..... A D1[L-1] A                        *
; *                    D2[0] A D2[1] A ..... A D2[M-1] A P                      *
; *                                                                             *
; *******************************************************************************
?IIC_Write_Sub_Write:
                mov     a,#_Write_Sub
                sjmp    _IICInOut
$EJECT
;
; *******************************************************************************
; * IIC_Write_Sub_Read:                                                         *
; *     PROCEDURE ( SlaveAddress, Count1, SourcePtr1, SubAddr,                  *
; *                               Count2, DestPtr2 ) BYTE / BIT / None ;        *
; *                                                                             *
; *     L   = Count1                                                            *
; *     D1  = SourcePtr1                                                        *
; *     M   = Count2                                                            *
; *     D2  = DestPtr2                                                          *
; *     Sub = SubAddr                                                           *
; *                                                                             *
; * IIC Format:                                                                 *
; *                                                                             *
; *     S SlvW A Sub A D1[0] A D1[1] A ..... A D1[L-1] A S SlvR A               *
; *                    D2[0] A D2[1] A ..... A D2[M-1] N P                      *
; *                                                                             *
; *******************************************************************************
?IIC_Write_Sub_Read:
                mov     a,#_Read_Sub
                sjmp    _IICInOut
;
IICInOutBlock2: mov     DataCount2,DataCount1
                mov     DataIndex2,DataIndex1
                mov     DataCount1,#0
                sjmp    _IICInOut
;
IICInOutBlock1: mov     DataCount2,#0
                ; Fall Into _IICInOut
;
$EJECT
;
;       ************************************************************************
;       *  _IICInOut                                                           *
;       *                                                                      *
;       *       Entry:                                                         *
;       *       Control byte definition in ACC:                                *
;       *                                                                      *
;       *       - Bit 7 = 1     Read Slave                                     *
;       *               = 0     Write Slave                                    *
;       *                                                                      *
;       *       - Bit 6 = 1     Slave is not a non-volatile memory             *
;       *               = 0     Slave is a non-volatile memory                 *
;       *                                                                      *
;       *       - Bit 5 = 1     Transeive without sub-address                  *
;       *               = 0     Transeive with sub-address                     *
;       *                                                                      *
;       *       - Bit 4 = 1     Slave without auto incrementing sub-address    *
;       *               = 0     Slave with auto incrementing sub-address       *
;       *                                                                      *
;       *       - Bit 3..Bit 0  Must be 0                                      *
;       *                                                                      *
;       *       Exit:                                                          *
;       *       Exit status If Transmission was succesfull:                    *
;       *                       A =  0, Carry = 0, IIC_Error = 0               *
;       *                   If Error During Transmission                       *
;       *                       A <> 0, Carry = 1, IIC_Error = 1               *
;       *                                                                      *
;       *       - on exit ACC contains exit status as described above          *
;       *                                                                      *
;       ************************************************************************
_IICInOut:      anl     IICCntrl,#00001111b             ; Clear old Mode Bits
                orl     IICCntrl,a                      ; Set new Mode Bits
;
                jb      IICCntrl.SLNOSUB,IICInOutKernel  ; Jump If No Sub-Adr
                jnb     IICCntrl.SLNOINCR,IICInOutKernel ; Jump If Auto Incr. Sub-Adr
;
;               *************************************************
;               * Slave with Non-Auto Incrementing Sub Address  *
;               *************************************************
                mov     DataIndex2,DataCount1           ; Use DataIndex2 as Local Count
                mov     DataCount1,#1                   ; Set Kernel Block 1 Count to 1
IICNextByte:    acall   IICInOutKernel                  ; Transeive one byte
                jnz     IICExit                         ; Exit on Error
                inc     SubAddress                      ; Increment Sub-Address
                inc     DataIndex1                      ; Increment Data Index
                jb      IICCntrl.SLNOMEM,IICSkipDelay   ; Skip if No Memory Device
                jb      IICCntrl.SLREAD,IICSkipDelay    ; Skip if Not Write
;
;               **********************************
;               * Delay After Write to NV Memory *
;               **********************************
                mov     r1,#2*NVM_Write_Delay           ; Delay 2 * NVM_Write_Delay * 0.5 msec
IICNVM_Delay1:  mov     r0,#249                         ; 500 usec delay
IICNVM_Delay2:  djnz    r0,IICNVM_Delay2                ; /
                djnz    r1,IICNVM_Delay1
;
IICSkipDelay:   djnz    DataIndex2,IICNextByte          ; Next Byte
                sjmp    IICExitOk                       ; Exit without Error
$EJECT
;
;       ************************************************************************
;       * IICInOutKernel                                                       *
;       *    From this Point on, all code in the file can be replaced with     *
;       *    IIC Software Emulation Kernel to provide IIC ( Single Master      *
;       *    only ) for 8051 controlers without hardware IIC Interface.        *
;       *    Needed code is available ( IIC51.ASM )                            *
;       ************************************************************************
;
IICInOutKernel: mov     r2,#IICRetries                  ; Retries on Error ( Norm. 5 )
IICInOutRetry:
                clr     ea                                   ; Disable Interrupts
                setb    sta                                  ; Start Master Mode Transfer
                anl     IICCntrl,#NOT ( mError + mInBlock2 ) ; Clear Error Bit, Start with Block 1
                setb    IICCntrl.MSTNOTREADY                 ; Indicate Master Not Ready
                setb    ea                                   ; Enable Interrupts
;
;               ***********************************************
;               * Wait for IIC Message Finished, with TimeOut *
;               ***********************************************
                mov     r1,#IICTimeOut                  ; IICTimeOut * 1 msec
IICWaitReady1:  mov     r0,#250                         ; Loop = 1 msec
IICWaitReady2:  jnb     IICCntrl.MSTNOTREADY,IICReady   ; Bit is Cleared if Ready
                djnz    r0,IICWaitReady2
                djnz    r1,IICWaitReady1
;
;               **********************************************
;               * Bus Timeout Occurred, Generate Bus Release *
;               **********************************************
                clr     ea                              ; Disable Interrupts
                mov     a,#mError                       ; Modify Status
                mov     r0,#IICCntrl                    ;  to Error
                xchd    a,@r0                           ; /
                mov     s1con,#NSTA_STO_AA              ; Forced Bus Release
                setb    ea                              ; Enable Interrupts
;
;               ****************************************
;               * Master Transfer is Ready, Test Error *
;               ****************************************
IICReady:       jnb     IICCntrl.ERROR,IICExitOk        ; If No Error Return Ok
                djnz    r2,IICInOutRetry                ; Retry if maximum is not exceeded
IICErrorExit:   mov     a,#1                            ; Else Return Error
                sjmp    IICExit                         ; /
IICExitOk:      clr     a                               ; Return OK
IICExit:        mov     c,acc.0                         ; Reflect Error in Carry
                mov     IIC_Error,c                     ; Reflect Error in IIC_Error
                ret
$EJECT
IICInitCode     Segment Code Unit
                Rseg    IICInitCode
;
;       *****************************************************************
;       * Init_IIC:                                                     *
;       *    PROCEDURE ( OwnSlaveAddress ) ;                            *
;       *    DECLARE OwnSlaveAddress BYTE ;                             *
;       *                                                               *
;       *    Initialises the IIC SIO1 data, sets the Own Slave Address  *
;       *                                                               *
;       *    NOTE: This procedure must be called                        *
;       *          after power on before use of any other IIC procedure *
;       *****************************************************************
?Init_IIC:       mov     s1adr,SlaveAddress              ; Setup Own Slave Address
                mov     s1con,#NSTA_NSTO_AA             ; Assert Acknowledge on Slave Address
                mov     IICCntrl,#0                     ; Initialise Control / Status Register
                setb    es1                             ; Enable SIO1 Interrupt
;
;               ************************************
;               * Use Next code If IIC Clock Speed *
;               * is generated by timer1           *
;               ************************************
;               orl     tmod,#00100000b                 ; Set timer1 AutoReload ( Mode 2 )
;               mov     th1,#IICTimerReload             ; Setup timer1 registers
;               mov     tl1,#IICTimerReload             ; /
;               setb    tr1                             ; Start timer
;
                ljmp    Init_Slave                      ; Do Slave dependent Initialisation
$EJECT
;       *****************************************
;       * ABSOLUTE SIO1 Interrupt Vector        *
;       *****************************************
                Cseg    At 002Bh                        ; SIO1 Interrupt Vector
                push    psw                             ; Save Program Status Word
                mov     psw,#08h                        ; Select Register Bank 1
                ljmp    IIC_Int                         ; Jump to Rest of Service Procedure
;
IICIntCode      Segment Code Unit
                Rseg    IICIntCode
;
;       *****************************************
;       * IIC_int                               *
;       *   SIO1 Interrupt Service Procedure    *
;       *****************************************
IIC_Int:        push    acc               ; Save Accumulator
                push    s1sta             ; Stack S1STA
                mov     a,#High SIOStates ; Stack High ( SIOStates )
                push    acc
                ret                       ; Transfer Control to the Stacked Address
$EJECT
IICIntStates    Segment Code Page       ; STATES MUST START ON A PAGE BOUNDARY
                Rseg    IICIntStates
;       *****************************************************************    *                                              
      
;       *       IIC ( SIO1 ) Interrupt Service Procedures               *
;       *                                                               *
;       *       - Activated by SIO1 Interrupt and Status Register s1sta *
;       *                                                               *
;       *       This Code Must Start on a Page Boundary !!!             *
;       *       Each State Procedure must be 8 Bytes Long !!!           *
;       *       If a Procedure doesn't fit in 8 Bytes a Jump must be    *
;       *       made to additional code.                                *
;       *                                                               *
;       *       Slv             - SlaveAddress                          *
;       *       SlvW            - SlaveAddress + Write                  *
;       *       SlvR            - Slave Address + Read                  *
;       *       Sub             - SubAddress                            *
;       *       D1[0..L-1]      - Array of Data Bytes ( DataIndex1 )    *
;       *       L               - Length of Array D1 ( DataCount1 )     *
;       *       D2[0..M-1]      - Array of Data Bytes ( DataIndex2 )    *
;       *       M               - Length of Array D2 ( DataCount2 )     *
;       *       S               - Start Condition                       *
;       *       P               - Stop Condition                        *
;       *       A               - Acknowledge                           *
;       *       N               - Negative Acknowledge                  *
;       *                                                               *
;       *       Master Transmitter Mode:                                *
;       *                                                               *
;       *       S SlvW   A Sub    A +                                   *
;       *       + D1[0]  A D1[1]  A .....  A D1[L-1]  A +               *
;       *       + D2[0]  A D2[1]  A .....  A D2[M-1]  A P               *
;       *                                                               *
;       *       ( Note: Sub is Optional, L and M may be 0 )             *
;       *                                                               *
;       *       Master Transmitter/Receiver Mode:                       *
;       *                                                               *
;       *       S SlvR   A D2[0]  A .....  A D2[M-1]  N P               *
;       *                                                               *
;       *       ( Note: M > 0 )                                         *
;       *                                                               *
;       *       S SlvW   A Sub    A +                                   *
;       *       + D1[0]  A .....  A D1[L-1]  A S SlvR A +               *
;       *       + D2[0]  A .....  A D2[M-1]  N P                        *
;       *                                                               *
;       *****************************************************************
;
SIOStates:
;               *********************************************************
;               * State 00:                                             *
;               *       Bus error during MST mode or selected SLV mode, *
;               *       due to an erroneous START or STOP condition     *
;               * Actions taken:                                        *
;               *       IICCntrl := Error                               *
;               *       Release Bus                                     *
;               *       Enter Not Addressed Slave Mode ( Assert ACK )   *
;               *********************************************************
                acall   SetError                ; Update Status
                mov     s1con,#NSTA_STO_AA      ; Release Bus, Not Addr. Slave Mode
                ajmp    SIO1Exit                ; Exit
                ds      1                       ; 2 + 3 + 2 + 1
;
;               *********************************************************
;               * State 08:     ( MST/TRX mode )                        *
;               *       A START condition has been transmitted          *
;               * Actions taken:                                        *
;               *       DataCount ( r2 ) and DataPointer ( r1 ) are     *
;               *       initialised for DataBlock1                      *
;               *       SLA + R/W are transmitted, ACK bit will be rec. *
;               *********************************************************
                mov     r2,DataCount1   ; Initialise DataCount ( r2 )
                mov     r1,DataIndex1   ; Initialise DataPointer ( r1 )
                clr     a               ; Default is Write
                ajmp    SendSlvAdr      ; Common Code with State 10
                ds      1               ; 2 + 2 + 1 + 2 + 1
;
;               *********************************************************
;               * State 10:     ( MST/TRX mode )                        *
;               *       A repeated START condition has been transmitted *
;               * Actions taken:                                        *
;               *       SLA + R are transmitted, ACK bit will be rec.   *
;               *********************************************************
                mov     a,#1                    ; Set Read Bit
SendSlvAdr:     orl     a,SlaveAddress          ; Combine with Slave Address
                clr     sta                     ; Clear Start Bit
                ajmp    SendAccExit             ; Send Data, Clr SI
;
;               *********************************************************
;               * State 18:     ( MST/TRX mode )                        *
;               *       SLA and W have been transmitted, ACK has been   *
;               *       received                                        *
;               * Actions taken:                                        *
;               *       If SUBADDRESS Then                              *
;               *         Xmitt Subaddress, ACK will be rec.            *
;               *       Else                                            *
;               *         Send Data or STOP                             *
;               *********************************************************
                jb      IICCntrl.SLNOSUB,JumpSendData ; Send Data if No Subaddr.
                mov     a,SubAddress            ; Pickup SubAddress
                ajmp    SendAccExit             ; Send it
                ds      1                       ; 3 + 2 + 2 + 1
;
;               *********************************************************
;               * State 20:     ( MST/TRX mode )                        *
;               *       SLA and W have been transmitted, NACK has been  *
;               *       received                                        *
;               * Actions taken:                                        *
;               *       IICCntrl := Error                               *
;               *       Send STOP Condition                             *
;               *********************************************************
State20:        acall   SetError                ; Return Error Status
                ajmp    SendStop                ; Send STOP Condition
                ds      4                       ; 2 + 2 + 4
;
;               *********************************************************
;               * State 28:     ( MST/TRX mode )                        *
;               *       DATA of S1DAT has been transmitted, ACK has     *
;               *       been received                                   *
;               * Actions taken:                                        *
;               *       ProceedSendData                                 *
;               *********************************************************
JumpSendData:   ajmp    SendData                ; Proceed with Sending Data
;
;               Space left is used by other Procedures:
MstRecHandleAck:cjne    r2,#1,KeepAA            ; If <> 1 then keep AA = 1
                clr     aa                      ; Else Assert NACK
KeepAA:         ret
                                                ; 2 + 3 + 2 + 1
;
;               *********************************************************
;               * State 30:     ( MST/TRX mode )                        *
;               *       DATA of S1DAT has been transmitted, NACK has    *
;               *       been received                                   *
;               * Actions taken:                                        *
;               *       IICCntrl := Error                               *
;               *       Send STOP Condition                             *
;               *********************************************************
                ajmp    State20                 ; Handle as State 20
;
;               Space left is used by other Procedures:
SetError:       mov     r0,#IICCntrl            ; Only Modify Lower Nibble ( = Status )
                mov     a,#mError               ; Set Error Flag in Status
                xchd    a,@r0                   ; /
                ret                             ; 2 + 2 + 2 + 1 + 1
;
;               *********************************************************
;               * State 38:     ( MST/TRX mode )                        *
;               *       Arbitration lost in SLA, R/W or DATA            *
;               * State 38:     ( MST/REC mode )                        *
;               *       Arbitration lost while returning ACK            *
;               * Actions taken:                                        *
;               *       Set STA to Start MST Mode when bus is free      *
;               *       Set AA ( AA was 0 during MST/REC of last byte ) *
;               *********************************************************
                mov     s1con,#STA_NSTO_AA      ; Set Start and Assert ACK
                clr     IICCntrl.INBLOCK2       ; Restart from Block 1
                ajmp    ClrSiExit               ; Clr SI
                ds      1                       ; 3 + 2 + 2 + 1
;
;               *********************************************************
;               * State 40:     ( MST/REC mode )                        *
;               *       SLA and R have been transmitted, ACK has been   *
;               *       received                                        *
;               * Actions taken:                                        *
;               *       Setup DataCount and DataIndex for Block 2       *
;               *       If DataCount <> 1 Then                          *
;               *         Keep Asserting ACK                            *
;               *       Else                                            *
;               *         Assert NACK                                   *
;               *********************************************************
                acall   SetupBlock2             ; Setup for Data Block 2
                acall   MstRecHandleAck         ; Handle Acknowledge
                ajmp    ClrSiExit               ; Exit
;
                ds      2                       ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State 48:     ( MST/REC mode )                        *
;               *       SLA and R have been transmitted, NACK has been  *
;               *       received                                        *
;               * Actions taken: ( As in State 20 )                     *
;               *       IICCntrl := Error                               *
;               *       Send STOP Condition                             *
;               *********************************************************
                ajmp    State20                 ; Handle as State 20
;
;               Space left is used by other Procedures:
FetchData:      dec     r2                      ; Decrement Data Count
                mov     @r1,s1dat               ; Save Received Data
                inc     r1                      ; Update Data Pointer
                ret
                ds      1                       ; 2 + 1 + 2 + 1 + 1 + 1
;
;               *********************************************************
;               * State 50:     ( MST/REC mode )                        *
;               *       DATA has been received, ACK has been returned   *
;               * Actions taken:                                        *
;               *       Fetch Data, Decr. Count, Incr. Pointer          *
;               *       If Count = 1 Then                               *
;               *         Assert NACK                                   *
;               *       Else                                            *
;               *         Assert ACK                                    *
;               *********************************************************
                acall   FetchData       ; Fetch Data
                acall   MstRecHandleAck ; Handle Acknowledge
                ajmp    ClrSiExit       ; Exit
;
                ds      2               ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State 58:     ( MST/REC mode )                        *
;               *       DATA has been received, NACK has been returned  *
;               * Actions taken:                                        *
;               *       Set AA ( Assert ACK again )                     *
;               *       Send Stop                                       *
;               *********************************************************
                acall   FetchData       ; Fetch Data
                setb    aa              ; Assert ACK
                ajmp    SendStop        ; Send Stop
                ds      2               ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State 60:     ( SLV/REC mode )                        *
;               *       Own SLA and W have been received, ACK has been  *
;               *       returned                                        *
;               * Actions taken:                                        *
;               *       IICCntrl ( Byte 1 Expected )                    *
;               *********************************************************
State60:        setb    IICCntrl.BYTE1EXPECTED  ; Update Status
                ajmp    ClrSiExit               ; Exit
;
                ds      4                       ; 2 + 2 + 4
;
;               *********************************************************
;               * State 68:     ( SLV/REC mode )                        *
;               *       Arbitration lost in SLA, R/W as MST. Own SLA    *
;               *       and W have been received, ACK has been returned *
;               * Actions taken:                                        *
;               *       IICCntrl ( Byte 1 Expected  )                   *
;               *       Set STA and AA                                  *
;               *********************************************************
State68:        setb    IICCntrl.BYTE1EXPECTED  ; Update Status
                clr     IICCntrl.INBLOCK2       ; Reset MST Status
                setb    aa                      ; Be Sure we Assert ACK
                ajmp    SendStart               ; Set Start Bit
;
;               *********************************************************
;               * State 70:     ( SLV/REC mode )                        *
;               *       General CALL+W has been received, ACK has been  *
;               *       returned ( Only if General CALL Enabled )       *
;               * Actions taken:                                        *
;               *       As State 60                                     *
;               *********************************************************
                ajmp    State60                 ; Handle as State 60
                ds      6
;
;               *********************************************************
;               * State 78:     ( SLV/REC mode )                        *
;               *       Arbitration lost in SLA, R/W as MST. General    *
;               *       CALL+W has been received, ACK has been returned *
;               *       ( Only if General CALL Enabled )                *
;               * Actions taken:                                        *
;               *       As State 68                                     *
;               *********************************************************
                ajmp    State68                 ; Handle as State 68
                ds      6
;
;               *********************************************************
;               * State 80:     ( SLV/REC mode )                        *
;               *       Previously addressed with own SLA. DATA byte    *
;               *       received, ACK returned                          *
;               * Actions taken:                                        *
;               *       Receive_Slave                                   *
;               *********************************************************
State80:        acall   Receive_Slave           ; Receive Slave Data
                ajmp    ClrSiExit               ; Exit
                ds      4                       ; 2 + 2 + 4
;
;               *********************************************************
;               * State 88:     ( SLV/REC mode )                        *
;               *       Previously addressed with own SLA. DATA byte    *
;               *       received, NACK returned                         *
;               *       ( Not addressed as slave anymore )              *
;               * Actions taken:                                        *
;               *       Dummy Read Data, Assert ACK                     *
;               *********************************************************
State88:        mov     a,s1dat                 ; Dummy read
                setb    aa                      ; Assert ACK
                ajmp    ClrSiExit               ; Exit
                ds      2                       ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State 90:     ( SLV/REC mode )                        *
;               *       Previously addressed with general CALL.         *
;               *       DATA byte received, ACK returned                *
;               * Actions taken:                                        *
;               *       Handled as State 80                             *
;               *********************************************************
                ajmp    State80                 ; Handle as State 80
;
;               Space left is used by other Procedures:
SetupBlock2:    setb    IICCntrl.INBLOCK2       ; Mark in Block 2
                mov     r1,DataIndex2           ; Pickup Pointer to Block 2
                ajmp    SetupB2Proceed          ; Proceed
                                                ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State 98:     ( SLV/REC mode )                        *
;               *       Previously addressed with general CALL.         *
;               *       DATA byte received, NACK returned               *
;               * Actions taken:                                        *
;               *       Handled as State 88                             *
;               *********************************************************
                ajmp    State88                 ; Handle as State 88
;
;               Space left is used by other Procedures:
SetupB2Proceed: mov     r2,DataCount2           ; Pickup Length Block 2
                ret
                ds      3                       ; 2 + 2 + 1 + 3
;
;               *********************************************************
;               * State A0:     ( SLV/REC mode )                        *
;               *       A STOP condition or repeated START condition    *
;               *       has been received while still addressed as      *
;               *       SLV/REC or SLV/TRX                              *
;               * Actions taken:                                        *
;               *       Clear IICCntrl ( Byte 1 expected )                      *
;               *********************************************************
StateA0:        clr     IICCntrl.BYTE1EXPECTED  ; Update Status
                setb    aa                      ; Assert Acknowledge Own Slave Address
                ajmp    ClrSiExit               ; Exit
                ds      2                       ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State A8:     ( SLV/TRX mode )                        *
;               *       Own SLA and R have been received, ACK returned  *
;               * Actions taken:                                        *
;               *       Send_Slave                                      *
;               *********************************************************
StateA8:        acall   Send_Slave                ; Send Slave Data
                ajmp    ClrSiExit                 ; Exit
                ds      4                         ; 2 + 2 + 4
;
;               *********************************************************
;               * State B0:     ( SLV/TRX mode )                        *
;               *       Arbitration lost in SLA, R/W as MST. Own SLA    *
;               *       R have been received, ACK returned              *
;               * Actions taken:                                        *
;               *       Set STA + AA                                    *
;               *       As State A8                                     *
;               *********************************************************
                setb    sta                     ; Set Start Bit
                setb    aa                      ; Set Assert ACK
                ajmp    StateA8                 ; Send Data
                ds      2                       ; 2 + 2 + 4
;
;               *********************************************************
;               * State B8:     ( SLV/TRX mode )                        *
;               *       DATA byte has been transmitted, ACK received    *
;               * Actions taken:                                        *
;               *       As State A8                                     *
;               *********************************************************
                ajmp    StateA8                 ; Send as Slave
SendStart:      setb    sta                     ; Send a START Condition
                ajmp    ClrSiExit               ; Exit
                ds      2                       ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State C0:     ( SLV/TRX mode )                        *
;               *       DATA byte has been transmitted, NACK received   *
;               * Actions taken:                                        *
;               *       As State A0                                     *
;               *********************************************************
                ajmp    StateA0                 ; Handle as State A0
;
;               Space Left is used by other Procedures
SendStop:       setb    sto                     ; Else Send Stop
                clr     IICCntrl.MSTNOTREADY    ; Clear the Not Ready Bit for MAIN
                ajmp    ClrSiExit               ; Exit
                                                ; 2 + 2 + 2 + 2
;
;               *********************************************************
;               * State C8:     ( SLV/TRX mode )                        *
;               *       Last DATA byte has been transmitted ( AA = 0 ), *
;               *       ACK received ( Normally not Used )              *
;               * Actions taken:                                        *
;               *       As State A0                                     *
;               *********************************************************
                ajmp    StateA0                 ; Handle as State A0
;
;               ********************************************
;               * Common Exits for SIO1 Service Procedures *
;               ********************************************
SendData:       cjne    r2,#0,ProceedSend          ; Send Data If There is any
                jb      IICCntrl.INBLOCK2,SendStop ; Send Stop If in Block 2
                acall   SetupBlock2                ; Else Setup Block 2
                jnb     IICCntrl.SLREAD,SendData   ; If Not Read Mode Then Send Block 2
                ajmp    SendStart                  ; Else Send a Repeated START Condition
;
ProceedSend:    dec     r2                      ; Decrement Data Count
                mov     a,@r1                   ; Pickup Data
                inc     r1                      ; Update Data Pointer
;
SendAccExit:    mov     s1dat,a                 ; Output Data
ClrSiExit:      clr     si                      ; Clear SI ( Service Interrupt )
SIO1Exit:       pop     acc                     ; Restore Acc
                pop     psw                     ; Restore Processor Status
                reti                            ; Exit Interrupt
$EJECT
;
;               *********************************************************
;               * Init_Slave                                            *
;               *********************************************************
Init_Slave:     ret                             ; No Init Needed
;
;               *********************************************************
;               * Receive_Slave                                         *
;               *                                                       *
;               * Actions taken:                                        *
;               *       If IICCntrl ( Byte 1 Expected ) Then            *
;               *         IICCntrl ( Byte 1 Expected ) := 0             *
;               *         SubAddress := s1dat                           *
;               *       Else                                            *
;               *         @SubAddress := s1dat                          *
;               *         SubAddress                                    *
;               *********************************************************
Receive_Slave:  mov     a,s1dat                         ; Pickup Received Data
                mov     r0,#r17                         ; Point to SubAddress
                jbc     IICCntrl.BYTE1EXPECTED,SaveData ; If BYTE1 Save Data in SubAddress
                mov     r0,r17                          ; Else Point @SubAddress
                inc     r7                              ; Post Increment SubAddress
SaveData:       mov     @r0,a                           ; Save Data
                ret
;
;               *********************************************************
;               * Send_Slave                                            *
;               *                                                       *
;               * Actions taken:                                        *
;               *       s1dat := @SubAddress                            *
;               *       SubAddress ++                                   *
;               *********************************************************
Send_Slave:     mov     r0,r17
                mov     s1dat,@r0
                inc     r7
                ret
;
                end     ;

